// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338
//+------------------------------------------------------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------------------------------------------------------+
// not for sale, rent, auction, nor lease

#property description                                                                   "[!!!-MT4 X-XARDg-INSIDE BAR]"
#define Version                                                                                   "[XARDg-INSIDE BAR]"
//+------------------------------------------------------------------------------------------------------------------+
#property link        "https://forex-station.com/viewtopic.php?p=1295409935#p1295409935"
#property description "THIS IS A FREE INDICATOR"
#property description "                                                      "
#property description "Welcome to the World of Forex"
#property description "Let light shine out of darkness and illuminate your world"
#property description "and with this freedom leave behind your cave of denial"
#property version       "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 3
extern string Indicator=Version;
//+------------------------------------------------------------------------------------------------------------------+
extern ENUM_TIMEFRAMES    TF_find               = PERIOD_H4;   
extern string             note1                 = "------------------------------";
extern color              UpperLineColor        = C'246,103,83';
extern color              MiddleLineColor       = clrDimGray; //clrSnow;
extern color              LowerLineColor        = C'246,103,83';
extern int                UpperLineWidth        = 2;
extern int                MiddleLineWidth       = 0;
extern int                LowerLineWidth        = 2;
extern int                UpperLineCode         = 251; //159;
extern int                MiddleLineCode        = 251; //119;
extern int                LowerLineCode         = 251; //167;

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
input string              btn_text             = "IB";              // Display id
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                // btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 200;               // Horizontal location
extern int                button_y              = 33;                // Vertical location
extern int                btn_Width             = 60;                // btn__width
extern int                btn_Height            = 20;                // btn__height
extern string             button_note2          = "------------------------------";
bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;

bool showInsideBar=true;
double HighBuff[],LowBuff[],MidBuff[],LastHigh,LastLow; int length=5,len=0,Type;
//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
string buttonId;

int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "InsideBar2020";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
   init2();
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here
	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   //put start () here
   start2();
      if (show_data)
         {
           ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
           for (int banzai=0; banzai<indicator_buffers; banzai++)
               SetIndexStyle(banzai,DRAW_ARROW);
         }
      else
         {
           ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
           for (int banzai2=0; banzai2<indicator_buffers; banzai2++)
               SetIndexStyle(banzai2,DRAW_NONE);
         }
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
   int init2(){
   if(TF_find==PERIOD_CURRENT) TF_find=(ENUM_TIMEFRAMES)_Period;
   if(Period()==PERIOD_H4){TF_find=PERIOD_H4;}
   LoadHist(); 
   if(showInsideBar)    Type=DRAW_ARROW; else Type=DRAW_NONE;
   if(Period()>PERIOD_H4) {Type=DRAW_NONE;}
   SetIndexBuffer(0,HighBuff); SetIndexStyle(0,Type,0,UpperLineWidth,UpperLineColor);   SetIndexArrow(0,UpperLineCode);
   SetIndexBuffer(1,LowBuff);  SetIndexStyle(1,Type,0,LowerLineWidth,LowerLineColor);   SetIndexArrow(1,LowerLineCode);
   SetIndexBuffer(2,MidBuff);  SetIndexStyle(2,Type,1,MiddleLineWidth,MiddleLineColor); SetIndexArrow(2,MiddleLineCode);
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   ArrayInitialize(HighBuff,EMPTY_VALUE); 
   ArrayInitialize(LowBuff,EMPTY_VALUE);
   return(INIT_SUCCEEDED);}
//+------------------------------------------------------------------------------------------------------------------+
int  start2()
{
//+------------------------------------------------------------------------------------------------------------------+
   int limit=1;  
   {
      ArrayInitialize(HighBuff,EMPTY_VALUE); 
      ArrayInitialize(LowBuff,EMPTY_VALUE);
       limit=iBars(_Symbol,TF_find)-2;}
//+-----      
   for(int i=limit; i>=1; i--){
     datetime time1=iTime(_Symbol,TF_find,i);
     datetime time2=time1+PeriodSeconds(TF_find);
   int bar_now=iBarShift(_Symbol,_Period,time1,false);
//+-----
   if(iLow(_Symbol,TF_find,i) > iLow(_Symbol,TF_find,i+1) && 
     iHigh(_Symbol,TF_find,i) < iHigh(_Symbol,TF_find,i+1) && 
     iHigh(_Symbol,TF_find,i)-iLow(_Symbol,TF_find,i)>_Point/2){
      LastHigh = iHigh(_Symbol,TF_find,i+0); LastLow = iLow(_Symbol,TF_find,i+0); len=1;
      
   if(bar_now<Bars-3 && 
      ((HighBuff[bar_now+1]!=LastHigh && HighBuff[bar_now+2]!=EMPTY_VALUE) ||
       (LowBuff[bar_now+1]!=LastLow && LowBuff[bar_now+2]!=EMPTY_VALUE))){
        HighBuff[bar_now+1] = EMPTY_VALUE;
         LowBuff[bar_now+1] = EMPTY_VALUE;}
        
   while (bar_now<Bars-2 && Time[bar_now]>=time1 && Time[bar_now]<time2){
      HighBuff[bar_now] = LastHigh;
       LowBuff[bar_now] = LastLow; bar_now--;
       MidBuff[bar_now]=(HighBuff[bar_now]+LowBuff[bar_now])/2;}} else {
   if(len>0 && len<length){while (bar_now<Bars-2 && Time[bar_now]>=time1 && Time[bar_now]<time2){
      HighBuff[bar_now] = HighBuff[bar_now+1];
       LowBuff[bar_now] = LowBuff[bar_now+1]; 
       MidBuff[bar_now]=(HighBuff[bar_now]+LowBuff[bar_now])/2; bar_now--;}  len++;} else 
   if(len>length){len=0;
      HighBuff[bar_now] = EMPTY_VALUE;
       LowBuff[bar_now] = EMPTY_VALUE;
       MidBuff[bar_now]=(HighBuff[bar_now]+LowBuff[bar_now])/2;}}}  return(0);}
//+------------------------------------------------------------------------------------------------------------------+
   string TFtoStr(int n){if(n==0)n=Period(); switch(n){
      case PERIOD_M1:  return ("M1");
      case PERIOD_M5:  return ("M5");
      case PERIOD_M15: return ("M15");
      case PERIOD_M30: return ("M30");
      case PERIOD_H1:  return ("H1");
      case PERIOD_H4:  return ("H4");
      case PERIOD_D1:  return ("D1");
      case PERIOD_W1:  return ("W1");
      case PERIOD_MN1: return ("MN1");}  return("TF?");}
//+------------------------------------------------------------------------------------------------------------------+
   void LoadHist(){int iPeriod[2];
   iPeriod[0]=TF_find;  iPeriod[1]=_Period;
   for(int i=0;i<2;i++){datetime open = iTime(_Symbol,iPeriod[i],0);
   int error=GetLastError(); while(error==4066){Comment("Loading history "+TFtoStr(iPeriod[i]));
      Sleep(1000); open = iTime(_Symbol,iPeriod[i],0); error=GetLastError();} Comment("");}}
//+------------------------------------------------------------------------------------------------------------------+
