// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338
// ma_with_button.mq4
//+------------------------------------------------------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------------------------------------------------------+
// modified by banzai from Mario Jemic template 
// July 28th, 2020
// not for sale, rent, auction, nor lease
#property strict

#property indicator_chart_window

#property indicator_buffers 19
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID //STYLE_DOT
#property indicator_style3 STYLE_SOLID

#property indicator_color1  clrDarkGray //upperband 1
#property indicator_color2  clrMagenta //Moving Average
#property indicator_color3  clrDarkGray //lowerband 1

#property indicator_color4  clrDarkGray //upperband 2
#property indicator_color5  clrDarkGray //lowerband 2
#property indicator_color6  clrDarkGray //upperband 3
#property indicator_color7  clrDarkGray //lowerband 3
#property indicator_color8  clrDarkGray //upperband 4
#property indicator_color9  clrDarkGray //lowerband 4
#property indicator_color10 clrDarkGray //upperband 5
#property indicator_color11 clrDarkGray //lowerband 5

#property indicator_color12 clrDarkGray //upperband 6
#property indicator_color13 clrDarkGray //lowerband 6
#property indicator_color14 clrDarkGray //upperband 7
#property indicator_color15 clrDarkGray //lowerband 7
#property indicator_color16 clrDarkGray //upperband 8
#property indicator_color17 clrDarkGray //lowerband 8
#property indicator_color18 clrDarkGray //upperband 9
#property indicator_color19 clrDarkGray //lowerband 9

extern int                BandsPeriod           = 21; // Bands period
extern int                BandsShift            = 0; // Bands shift
extern double             BandsDeviations1      = 1.382; // Bands deviations
extern string             note1                 = "------------------------------";
extern bool               DisplayMultipleBands  = true;
extern double             BandsDeviations2      = 1.5; // Bands deviations
extern double             BandsDeviations3      = 1.618; // Bands deviations
extern double             BandsDeviations4      = 1.764; // Bands deviations
extern double             BandsDeviations5      = 2.0; // Bands deviations
extern double             BandsDeviations6      = 2.236; // Bands deviations
extern double             BandsDeviations7      = 2.382; // Bands deviations
extern double             BandsDeviations8      = 2.5; // Bands deviations
extern double             BandsDeviations9      = 2.618; // Bands deviations
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "BB";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 140;                                     //btn__x
extern int                button_y              = 33;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
int myTimeFrame           = PERIOD_CURRENT;
double Up1[], Center1[], Down1[], Up2[], Down2[], Up3[], Down3[], Up4[], Down4[], Up5[], Down5[];
double Up6[], Down6[], Up7[], Down7[], Up8[], Down8[], Up9[], Down9[], Up10[], Down10[];
//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
string buttonId;

int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "BollingerBand2020";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
   SetIndexBuffer(0, Up1);
   SetIndexBuffer(1, Center1);
   SetIndexBuffer(2, Down1);
   
   SetIndexBuffer(3,  Up2);
   SetIndexBuffer(4,  Down2);
   SetIndexBuffer(5,  Up3);
   SetIndexBuffer(6,  Down3);
   SetIndexBuffer(7,  Up4);
   SetIndexBuffer(8,  Down4);
   SetIndexBuffer(9,  Up5);
   SetIndexBuffer(10, Down5);
   SetIndexBuffer(11, Up6);
   SetIndexBuffer(12, Down6);
   SetIndexBuffer(13, Up7);
   SetIndexBuffer(14, Down7);
   SetIndexBuffer(15, Up8);
   SetIndexBuffer(16, Down8);
   SetIndexBuffer(17, Up9);
   SetIndexBuffer(18, Down9);

   for (int banzai=0; banzai<indicator_buffers; banzai++)   
        SetIndexStyle (banzai, DRAW_LINE);

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here

	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   //put start () here
   int ExtCountedBars = IndicatorCounted();
   if (ExtCountedBars < 0) 
      return -1;
   int pos = Bars - 2;
   if (ExtCountedBars > 2 && !recalc) 
      pos = Bars - ExtCountedBars - 1;
   while (pos >= 0)
   {
         int period  = iBarShift(NULL, myTimeFrame, Time[pos], true);
         Up1[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations1, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
         Down1[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations1, BandsShift, PRICE_CLOSE, MODE_LOWER, period);
         Center1[pos] = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations1, BandsShift, PRICE_CLOSE, MODE_MAIN,  period);
         if (DisplayMultipleBands)
            {
                        Up2[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations2, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down2[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations2, BandsShift, PRICE_CLOSE, MODE_LOWER, period);
            
                        Up3[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations3, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down3[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations3, BandsShift, PRICE_CLOSE, MODE_LOWER, period);

                        Up4[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations4, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down4[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations4, BandsShift, PRICE_CLOSE, MODE_LOWER, period);

                        Up5[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations5, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down5[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations5, BandsShift, PRICE_CLOSE, MODE_LOWER, period);

                        Up6[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations6, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down6[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations6, BandsShift, PRICE_CLOSE, MODE_LOWER, period);

                        Up7[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations7, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down7[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations7, BandsShift, PRICE_CLOSE, MODE_LOWER, period);

                        Up8[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations8, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down8[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations8, BandsShift, PRICE_CLOSE, MODE_LOWER, period);

                        Up9[pos]     = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations9, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
                        Down9[pos]   = iBands(NULL, myTimeFrame, BandsPeriod, BandsDeviations9, BandsShift, PRICE_CLOSE, MODE_LOWER, period);           
           }
       else
      {
         Up1[pos]     = EMPTY_VALUE;
         Down1[pos]   = EMPTY_VALUE;
         Center1[pos] = EMPTY_VALUE;
         if (DisplayMultipleBands)
            {        
              Up2[pos]     = EMPTY_VALUE;
              Down2[pos]   = EMPTY_VALUE;
              Up3[pos]     = EMPTY_VALUE;
              Down3[pos]   = EMPTY_VALUE;
              Up4[pos]     = EMPTY_VALUE;
              Down4[pos]   = EMPTY_VALUE;
              Up5[pos]     = EMPTY_VALUE;
              Down5[pos]   = EMPTY_VALUE;
              Up6[pos]     = EMPTY_VALUE;
              Down6[pos]   = EMPTY_VALUE;
              Up7[pos]     = EMPTY_VALUE;
              Down7[pos]   = EMPTY_VALUE;
              Up8[pos]     = EMPTY_VALUE;
              Down8[pos]   = EMPTY_VALUE;
              Up9[pos]     = EMPTY_VALUE;
              Down9[pos]   = EMPTY_VALUE;
         }
      }
      pos--;
   } 
 
      if (show_data)
         {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
         for (int banzai=0; banzai<indicator_buffers; banzai++)
             SetIndexStyle(banzai,DRAW_LINE);
         }
      else
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
       for (int banzai=0; banzai<indicator_buffers; banzai++)
           SetIndexStyle(banzai,DRAW_NONE);
      }
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
